﻿using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDockManagerSplitPane
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<FrameworkElement> paneCollection;
        DependencyObject parent;

        public MainWindow()
        {
            InitializeComponent();
        }       

        private void XamDockManager_PaneDragEnded(object sender, Infragistics.Windows.DockManager.Events.PaneDragEndedEventArgs e)
        {
            ObservableCollection<FrameworkElement> newPaneCollection = new ObservableCollection<FrameworkElement>();
            if (paneCollection.Count > 0)
            {
                foreach (var pane in paneCollection)
                {
                    newPaneCollection.Add(pane);                   
                }
                (parent as SplitPane).Panes.Clear();

                foreach (var item in newPaneCollection)
                {
                    if ((e.Panes[0].Parent is SplitPane))
		             (e.Panes[0].Parent as SplitPane).Panes.Add(item);
                    if ((e.Panes[0].Parent is TabGroupPane))
                        ((e.Panes[0].Parent as TabGroupPane).Parent as SplitPane).Panes.Add(item);
	            }
            }
        }

        private void XamDockManager_PaneDragStarting(object sender, Infragistics.Windows.DockManager.Events.PaneDragStartingEventArgs e)
        {
            parent = e.Panes[0].Parent;
            if ((parent as SplitPane) != null)
            {
                paneCollection = (parent as SplitPane).Panes;                
            }
        }
    }
}
